<?php

namespace App\Http\Controllers;

use App\Models;
use Illuminate\Http\Request;
use Mockery\Exception;
use Illuminate\Support\Facades\Log;

// todo 返回值为 数字代码还是json还是其他格式待定

class PermissionController extends Controller
{

    /**
     * 分配用户可以查看的菜单的内容
     *
     * @param Request $request
     * @return string
     */
    public function AssignActionBars(Request $request)
    {
        // 这里的uid从中间件那里获得
//        $currentUid = $request->input("currentUid");
        $uid = $request->input("uid"); // 被修改权限用户的id
        $barIds = $request->input("barIds");

        $currentUid = 1;
        // 判断当前用户是否有权分配权限
        $userRole = new Models\UserRole();
        $role = $userRole->LoadRoleByUid($currentUid);

        if (!$role || $role->status != "normal" || $role->role & 1 == 0) {
            return "permission denied";
        }

        // 有权分配
        $userActionBar = new Models\UserActionBarController();
        $userActionBar->AddUserActionBar($uid, $barIds);
        return "success";
    }

    /**
     * 分配用户的是否是管理员或者普通用户的权限
     *
     * @param Request $request
     * @return string
     */
    public function AssignUserRole(Request $request)
    {
        $uid = $request->input("uid");
        $roles = $request->input("roles");

        $currentUid = 1;
        $userRole = new Models\UserRole();
        $role = $userRole->LoadRoleByUid($currentUid);

        if (!$role || $role->status != "normal" || $role->role & 1 == 0) {
            return "permission denied";
        }

        // 有权分配
        $userRole->AssignRoles($uid, $role);
        return"success";
    }
}
