<?php

namespace App\Http\Controllers;

use App\Models;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

// todo 返回值为 数字代码还是json还是其他格式待定
class UserController extends Controller
{
    public function CreateUser(Request $request)
    {

        $validator = Validator::make($request->all(), [
            "username" => "required|between:1,3",
            "password" => "required|between:8,16",
        ]);
        if ($validator->fails()) {
            return $this->fail(REQUEST_PARAM_ERROR, $this->error[REQUEST_PARAM_ERROR], $validator->errors());
        }

        $params = [];
        $params["username"] = $request->input("username");
        $params["password"] = $request->input("password");
        $params["nickname"] = $request->input("nickname");
        $params["icon"] = $request->input("icon");
        $params["tel"] = $request->input("tel");
        $params["email"] = $request->input("email");

        $user = new Models\User();
        $result = $user->CreateUser($params);
        return $this->success($result);
    }

    public function ModifyUser(Request $request)
    {
        $validator = Validator::make($request->all(),[
            "id" => "required|gt:0"
        ]);
        if ($validator->fails()){
            return $this->fail(REQUEST_PARAM_ERROR, $this->error[REQUEST_PARAM_ERROR], $validator->errors());
        }

        $params = [];
        $params["id"] = $request->input("id");
        $params["username"] = $request->input("username");
        $params["password"] = $request->input("password");
        $params["nickname"] = $request->input("nickname");
        $params["icon"] = $request->input("icon");
        $params["tel"] = $request->input("tel");
        $params["email"] = $request->input("email");

        $user = new Models\User();
        $result = $user->ModifyUser($params);
        if ($result["code"] == 0){
            return $this->success("success");
        } else{
            $code = $result["code"];
            return $this->fail($code, $this->error[$code]);
        }
    }

    public function DeleteUser(Request $request)
    {
        $uid = $request->input("id");

        $user = new Models\User();
        $result = $user->DeleteUser($uid);
        return $result;
    }

    public function ListUser(Request $request)
    {
        $page = $request->input("page");
        $pageCount = $request->input("pageCount");

        $user = new Models\User();
        $result = $user->ListUser($page, $pageCount);
        return $result;
    }
}
